package WebSearch;

use 5.008;
#use strict;
use warnings;

require Exporter;


our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use WebSearch ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(	) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(qsearch qhits);

our $VERSION = '0.01';


# Preloaded methods go here.

sub qsearch
{
   

use LWP::Simple;                                                                       # Using LWP package 
use HTML::TokeParser;                                                                  # Using HTML parser interface 

$word = "";
$number_of_sentences = 0;
$word = $_[0];
$number_of_pages = 1;

if(exists $_[1])                                                                       # Checking if the user wants a particular number of sentences
{
#    print "INSIDE NO SENTENCES : $_[1]\n";
    $number_of_sentences = $_[1];
    if(exists $_[2])
    {
	$number_of_pages = $_[2];
    }
}
my $qry =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word."&avkw=rf"; # construct query from word

#open(OUTFILE,">sentences.txt");




my $content = get($qry);                                                               # get the HTML layout of the webpage in a variable                                           
my %hash = ();
my %has1 = ();
my $i;
my $url;

if (defined $content)
{
    my $try;
    $try = $content;
    $try =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test1 = $';
	my $var;
	my $match;
	$var = $&;
	my @temparr = split/ /,$var;
	$match = $temparr[2];
	$match =~ s/,//g;
	$test = $test1;
	$test =~ m/Add your Web site\'s pages to AltaVista search results with/;
	if(defined $&)
	{
	    $content = $`;
 	    #$content will contain the html associated with the url mentioned
	    my $stream = HTML::TokeParser->new(\$content);
	    while (my $token = $stream->get_tag("a"))                                     # loop to extract all links from HTML document
	    {                                                                             # reference : http://www.perldoc.com/perl5.8.0/lib/HTML/TokeParser.html

		my $url = $token->[1]{href} || "-";
		$hash{$url}++;
	    }                                                                             # end of reference
	}
	if($match > 10 and $number_of_pages > 1)                                                               # to check if there are more than 10 matches
	{
	    $i = 10;
	    my $pgcnt = int($match/10);
	    $pgcnt = $pgcnt + 1;
	    my $ctr = 1;
	    while($ctr <= $pgcnt && $ctr <= $number_of_pages)                                      # scans through rest of the search pages of Altavista
	    {
         	$url = "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word."&avkw=rf&stq=" . $i;
		$content = get($url);
		$i += 10;
		if(defined $content)
		{
		    $try = $content;
		    $try =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
		    if(defined $&)
		    {
			$test1 = $';
			$test = $test1;
			$test =~ m/Add your Web site\'s pages to AltaVista search results with/;
			if(defined $&)
			{
			    $content = $`;
			    #$content will contain the html associated with the url mentioned
			    $stream = HTML::TokeParser->new(\$content);
			    my $token;
			    while ($token = $stream->get_tag("a"))                            # extracts all links from HTML document 
			    {                                                                 # reference http://www.perldoc.com/perl5.8.0/lib/HTML/TokeParser.html
				$url = $token->[1]{href} || "-";
				$hash{$url}++;
			    }                                                                 # end of reference
			}
		    }
		}
		$ctr++;
	    }
	}
    }
    else
    {
	print "No matches were found for the word.\n";
    }
}



else
{
    #If an error occurs then $content will not be defined.
    print "Error: Get failed";
}

#print "Done With getting urls....\n\n";

my $complete = "";

foreach $url(keys %hash)
{
    $url =~ m/www(.)*/;                                                            # searching through all documents whose links are stored in the hash
    if (defined $&)
    {
	$url = $&;
	$url =~ s/%2F/\//g;
	$url =~ s/&language\=en//g;
	$url =~ s/%.*$//;
	$url = "http://" . $url;
	$hash1{$url}++;
#	print "URL: $url\n\n\n\n";
    }
}

#print "Done with cleaning up urls....\n\n";

foreach $url(keys %hash1)
{
     $newcontent = get($url);
    if(defined $newcontent)
    {
#	print "GOTTEN URL: $url\n\n\n\n";
	$newcontent =~ s/<[^>]+>//g;
	$newcontent =~ s/\s+/ /g;
	$newcontent =~ s/\&.*?\;//g;
	$newcontent =~ s/[^A-Za-z0-9 \.]//g;
#	print "$newcontent\n\n\n";
	$complete .= $newcontent;                                               # concatenating all the data to one variable
     }
}

#print "Done with getting everything in one loooooooooooooooooooooooooooonnnng variable\n";


my @seperate_lines = ();  

@seperate_lines = split/[\.\?!]/,$complete;                                       # splitting sentences

my $reg_exp = "";

$reg_exp .= "[";

my @seperated_word = ();

@seperated_word = split//,$word;

$reg_exp .= $seperated_word[0];

$reg_exp .= uc($seperated_word[0]);

$reg_exp .= "]";

for($i=1;$i<=$#seperated_word;$i++)
{
    $reg_exp .= $seperated_word[$i];
}

my %sentence_hash = ();

$sent_count = 0;
for($i=0;$i<=$#seperate_lines;$i++)                                             # comparing sentences to see if the word required by user is present
{
    my $temp;
    $temp = $seperate_lines[$i];
    $temp =~ m/$reg_exp/;

    if($number_of_sentences > 0)
    {
	if($& and $sent_count < $number_of_sentences)
	{
	    
	    $temp =~ s/\/s+/ /g;
	    $temp =~ s/[^A-Za-z0-9 ]//g;
	    $sentence_hash{$temp}++;
	    if($sentence_hash{$temp} == 1)
	    {
		$sent_count++;
	    }
	
	    else
	    {
		$temp =~ s/\/s+/ /g;
		$temp =~ s/[^A-Za-z0-9 ]//g;
		$sentence_hash{$temp}++;
	    }
	}
    }
    else
    {
	if($&)
	{
	    $temp =~ s/\/s+/ /g;
	    $temp =~ s/[^A-Za-z0-9 ]//g;
	    $sentence_hash{$temp}++;
	}

    }
}

return %sentence_hash;
}


sub qhits
{
   

use LWP::Simple;                                                                       # Using LWP package 
use HTML::TokeParser;                                                                  # Using HTML parser interface 

open(FILE,"/home/cs/taka0078/Melgar/WebReader/webwords") or die "cant find file\n";

$word2 = <FILE>;
$word3 = <FILE>;


chomp($word2);
chomp($word3);


$word = "";
$number_of_sentences = 0;
$word = $word2 . "+NEAR+";
$word1 =$word3 . "+NEAR+";

$notquery = "NOT+" . $word2 . "+AND+NOT+" . $_[0];
$notquery1 = "NOT+" . $word3 . "+AND+NOT+" . $_[0];

open(CACHE,">>cache");

$cache_word = lc($_[0]);
print CACHE "$cache_word";

$word .= lc($_[0]);
$word1 .= lc($_[0]);
$actual = lc($_[0]);

my $qry =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word."&avkw=rf"; # construct query from word
my $qry1 =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word1."&avkw=rf"; # construct query from word
my $qry2 =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word2."&avkw=rf"; # construct query from word
my $qry3 =  "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$word3."&avkw=rf"; # construct query from word
my $qry4 = "http://www.altavista.com/web/res_text?amb=txt&q=text%3A".$actual."&avkw=rf"; #construct query from word
my $qry5 = "http://www.altavista.com/cg/results?pg=aq&avkw=qtrp&filetype=&aqmode=b&aqb=text%3A".$notquery."&aqs=&kgs=0&kls=0";
my $qry6 = "http://www.altavista.com/cg/results?pg=aq&avkw=qtrp&filetype=&aqmode=b&aqb=text%3A".$notquery1."&aqs=&kgs=0&kls=0";


my $content = get($qry); 

my $content1 = get($qry1);                                                              # get the HTML layout of the webpage in a variable                                     

my $content2 = get($qry2);

my $content3 = get($qry3);
;
my $content4 = get($qry4);

my $content5 = get($qry5);

my $content6 = get($qry6);


my %hash = ();
my %has1 = ();
my $i;
my $url;
my @returnarr = ();
if (defined $content)
{
    my $try;
    $try = $content;
    $try =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test1 = $';
	my $var;
	my $match;
	$var = $&;
	my @temparr = split/ /,$var;                                                  # getting the number of results obtained
	$match = $temparr[2];
	$match =~ s/,//g;
	$returnarr[0] = $match;    
        print CACHE " $match";
    }
    else
    {
        $returnarr[0] = 0;
        print CACHE " $returnarr[0]";
    }
}

if (defined $content1)
{
    my $try1;
    $try1 = $content1;
    $try1 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test2 = $';
	my $var1;
	my $match1;
	$var1 = $&;
	my @temparr1 = split/ /,$var1;
	$match1 = $temparr1[2];                                                         # getting the number of results obtained
	$match1 =~ s/,//g;
  	$returnarr[1] = $match1;
        print CACHE " $match1";
    }
    else
    {
        $returnarr[1] = 0;
        print CACHE " $returnarr[1]";

    }
}

if (defined $content2)
{
    my $try2;
    $try2 = $content2;
    $try2 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test3 = $';
	my $var2;
	my $match2;
	$var2 = $&;
	my @temparr2 = split/ /,$var2;                                                  # getting the number of results obtained
	$match2 = $temparr2[2];
	$match2 =~ s/,//g;
  	$returnarr[2] = $match2;
        print CACHE " $match2";

    }
    else
    {
        $returnarr[2] = 0;
        print CACHE " $returnarr[2]";

    }

}

if (defined $content3)
{
    my $try3;
    $try3 = $content3;
    $try3 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test3 = $';
	my $var3;
	my $match3;
	$var3 = $&;
	my @temparr3 = split/ /,$var3;                                                  # getting the number of results obtained
	$match3 = $temparr3[2];
	$match3 =~ s/,//g;
  	$returnarr[3] = $match3;
        print CACHE " $match3";

    }
    else
    {
        $returnarr[3] = 0;
        print CACHE " $returnarr[3]";

    }

}

if (defined $content4)
{
    my $try4;
    $try4 = $content4;
    $try4 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test4 = $';
	my $var4;
	my $match4;
	$var4 = $&;
	my @temparr4 = split/ /,$var4;                                                  # getting the number of results obtained
	$match4 = $temparr4[2];
	$match4 =~ s/,//g;
  	$returnarr[4] = $match4;
        print CACHE " $match4";

    }
    else
    {
        $returnarr[4] = 0;
        print CACHE " $returnarr[4]";

    }

}

if (defined $content5)
{

    my $try5;
    $try5 = $content5;
    $try5 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test5 = $';
	my $var5;
	my $match5;
	$var5 = $&;
	my @temparr5 = split/ /,$var5;                                                  # getting the number of results obtained
	$match5 = $temparr5[2];
	$match5 =~ s/,//g;
  	$returnarr[5] = $match5;
        print CACHE " $match5";

    }
    else
    {
        $returnarr[5] = 0;
        print CACHE " $returnarr[5]";

    }

}


if (defined $content6)
{

    my $try6;
    $try6 = $content6;
    $try6 =~ m/AltaVista found [0-9,]+ results/;                                        # check the numbers of results obtained by Altavista
    if(defined $&)
    {
	$test6 = $';
	my $var6;
	my $match6;
	$var6 = $&;
	my @temparr6 = split/ /,$var6;                                                  # getting the number of results obtained
	$match6 = $temparr6[2];
	$match6 =~ s/,//g;
  	$returnarr[6] = $match6;
        print CACHE " $match6";

    }
    else
    {
        $returnarr[6] = 0;
        print CACHE " $returnarr[6]";

    }

}
print CACHE "\n";
return @returnarr;
}
# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

  WebSearch - Perl extension for querying the World Wide Web

=head1 SYNOPSIS

   use WebSearch; qsearch(word [numsentences] [numpages]); qhits(word);

=head1 ABSTRACT

 

  This module  provides the functionality  to retrieve sentences  of a
  given word using  the Altavista search engine. It  also provides the
  number of results altavista returns for a particular word.


=head1 DESCRIPTION

  WebSearch is  a module  which can  be used to  gather data  from the
  web. The module has two functions. The first function is the qsearch
  function. This function is used to search for sentences that contain
  a  given  word,  the  word  being  passed  as  an  argument  to  the
  function. The usage of the qsearch function is as follows:

      qsearch(<word> [numsentences] [numpages]);

  There  are two  optional parameters  that this  function  takes. The
  first optional  parameter is a number  which can be used  to set the
  number  of  sentences  that a  user  wants  to  be retrieved  for  a
  particular word.  The second optional specifies the  number of pages
  that the  search engine  should look through  to gather  links which
  would then be accesed to get the sentences.

  The  other function  that  webSearch module  provides  in the  qhits
  function.  This function  takes in  as the  input, a  word  and then
  returns the number of hits this word had with <GOOD_WORD> near it or
  <BAD_WORD> near it.It basically  uses the Altavista keyword NEAR and
  searches a query like:

      <WORD> NEAR <GOOD_WORD>
      <WORD> NEAR <BAD_WORD>

  It also  searches for  both the <GOOD_WORD>  and the  <BAD_WORD> and
  then returns  the number of  hits it found  for each of these  in an
  array.The <GOOD_WORD> and <BAD_WORD> are picked up from a file named
  webwords that  is packaged along with  the module. The  user can set
  their  own good/bad  words to  suit their  purpose.The usage  of the
  qhits function is as follows:

      qhits(<word>);


**********************************************************************************************************
For coding of the programs the following resources were referred

Altavista.com --> to query the web

http://www.perldoc.com/perl5.8.0/lib/HTML/TokeParser.html --> to extract all the links from HTML document

Perl & LWP - O-Reilly Publications --> for usage of LWP package
*********************************************************************************************************

=head2 EXPORT

  qsearch qhits



=head1 SEE ALSO

    LWP::Simple();

=head1 AUTHOR

Nan Zhang E<lt>zhan0433@d.umn.eduE<gt>
Sumalatha Kothadi E<lt>koth0025@d.umn.eduE<gt>
Prashant Jain, E<lt>jain0069@d.umn.eduE<gt>
Anand Takale, E<lt>taka0078@d.umn.eduE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by melgarFBC

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut



