#!/usr/local/bin/perl



use bigmac;

system("clear");

print STDERR "\n\nBigMac Interface..............LOADING";

initialize();

while(1)
{
    system("clear");
    print "\n                                      \\\|/// ";
    print "\n                                    \\  ~ ~  // ";
    print "\n                                     (  @ @  )  ";
    print "\n**********************************-oOOo-(_)-oOOo-************************************";
    print "\n                                                                                        ";
    print "\n     BigMac Interface - Provided by Melgar FBC";
    print "\n                                                                                   ";
    print "\n     1. Query Dictionary by Word";      
    print "\n     2. Get all parts of speech from the dictionary";                                                                 
    print "\n     3. Get all words of particular part of speech";
    print "\n     4. Get all words that share the same Thesaurus Code as a given word";
    print "\n     5. Get words which contain the given words in their definition";
    print "\n     6. Exit";                                                                                                                      
    print "\n                                                                                  ";
    print "\n***************************************-OoooO-***************************************";
    print "\n                              .oooO     (   ) ";
    print "\n                              (   )      ) / ";
    print "\n                               \ (      (_/ ";
    print "\n                                \_) ";


    print "\n\nEnter choice : ";
    $ch = <STDIN>;
    chomp($ch);
    if($ch == 1)
    {

	print "\n\nEnter WORD : ";
	$word = <STDIN>;
	chomp($word);
	print "\n\n1. Complete information about the word";
	print "\n2. Part of speech";
	print "\n3. Pronounciation";
	print "\n4. Inflection ";
	print "\n5. Synonym";
	print "\n\nEnter Choice : ";
	$ch1 = <STDIN>;
	chomp($ch1);
	if($ch1==1)
	{
	    word_entries($word);
	}
	if($ch1==2)
	{
	    word_entries($word,"POS");
	}
	if($ch1==3)
	{
	    word_entries($word,"PRON");

	}
	if($ch1==4)
	{
	    word_entries($word,"INF");
	}
	if($ch1==5)
	{
	   %syn_hash =  word_entries($word,"SYN");
	   foreach $syn(keys %syn_hash)
	   {
	       print "$syn\n";
	   }
	}
    }

    if($ch == 2)                                                             # function that returns all parts of speech that are there in the BigMac dictionary
    {
	%pos_hash = ();
	%pos_hash = all_pos();
	foreach $pos(keys %pos_hash)
	{
	    print "\n$pos : $pos_hash{$pos}";
	}
    }

    if($ch == 3)                                                             # function that returns all words of a particular part of speech
    {
	%pos_hash = ();
	%word_hash = ();
	print "\n\nThe available POS are as follows :";
	print "\n\n";
	%pos_hash = all_pos();

       	foreach $pos(keys %pos_hash)
	{
	    print "\n$pos : $pos_hash{$pos}";
	}

	print "\n\nEnter any one of the above POS : ";
	$POS = <STDIN>;
	chomp($POS);

	%word_hash = particular_pos($POS);

	foreach $word(keys %word_hash)
	{
	    print "\n$word : $word_hash{$word}";
	}


    }
    if($ch == 4)
    {
	print "\n\nEnter word: ";
	$word = <STDIN>;
	chomp($word);
	%syn_hash = synonym($word);
	foreach $thescode(keys %syn_hash)
	{
	    print "THESAURUS CODE:$thescode\n";
	    foreach $thesword(keys %{$syn_hash{$thescode}})
	    {
		print "WORD: $thesword\n";
	    }
	}
    }

    if($ch == 5)
    {
	$ch2 = "y";
	$i = 0;
	@word = ();
	while($ch2 ne "n")
        {
	    print "\n\nThe words that you enter would be present in definitions of the outputted words "; 
	    print "\n\nEnter word : ";
	    $word[$i] = <STDIN>;
	    chomp($word[$i]);
	    $i++;
	    print "\n\nDo you want to enter another word?(y/n): ";
	    $ch2 = <STDIN>;
	    chomp($ch2);
	}
        %shared_def = shared_definition(@word);
	foreach $val(keys %shared_def)
	{
	    print "WORD: $val\n";
	    foreach $subval(keys %{$shared_def{$val}})
	    {
		print "$subval\n";
	    }
	}
    }
    if($ch == 6)
    {
	exit(0);
    }
    print "\n\nPress any key to continue ..........";
    <STDIN>;
}

