#!/usr/local/bin/perl

use ldoce;


while(1)
{
    system("clear");
    print "\n                                      \\\|/// ";
    print "\n                                    \\  ~ ~  // ";
    print "\n                                     (  @ @  )  ";
    print "\n**********************************-oOOo-(_)-oOOo-************************************";
    print "\n                                                                                        ";
    print "\n     LDOCE Interface - Provided by Melgar FBC";
    print "\n                                                                                   ";
    print "\n     1. Query Dictionary by Word";      
    print "\n     2. Get all parts of speech from the dictionary";                                                                 
    print "\n     3. Get words which contain the given words in their definitions";
    print "\n     4. Get all words of a part of speech";
    print "\n     5. Get all subject codes";
    print "\n     6. Get all words with the same subject codes";
    print "\n     7. Exit";                                                                                                                      
    print "\n                                                                                  ";
    print "\n***************************************-OoooO-***************************************";
    print "\n                              .oooO     (   ) ";
    print "\n                              (   )      ) / ";
    print "\n                               \ (      (_/ ";
    print "\n                                \_) ";


    print "\n\nEnter choice : ";
    $ch = <STDIN>;
    chomp($ch);
    if($ch == 1)
    {

	print "\n\nEnter WORD : ";
	$word = <STDIN>;
	$word = lc($word);
	chomp($word);
	print "\n\n1. Complete information about the word";
	print "\n2. Hypenation";
	print "\n3. Pronunciation";
	print "\n4. Frequency ";
	print "\n5. Part of speech";
	print "\n6. Inflections";
	print "\n7. Sense";
	print "\n8. Tail";
	print "\n\nEnter Choice : ";
	$ch1 = <STDIN>;
	chomp($ch1);
	if($ch1==1)
	{
	    find_word($word);
	}
	if($ch1==2)
	{
	    find_word($word,"hyp");
	}
	if($ch1==3)
	{
	    find_word($word,"pron");

	}
	if($ch1==4)
	{
	    find_word($word,"freq");
	}
	if($ch1==5)
	{
	    find_word($word,"pos");
	}
	if($ch1==6)
	{
	    find_word($word,"inf");
	}
	if($ch1==7)
	{
	    find_word($word,"sen");
	}
	if($ch1==8)
	{
	    find_word($word,"tail");
	}
	
    }
    if($ch == 2)   # return a hash
    {
	%result_hash = ();
	%result_hash = all_pos();
	

	print "\n\nAll parts of Speech in the LDOCE Dictionary\n\n";
	foreach $record(keys %result_hash)
	{
	    print "\n$record : $result_hash{$record}";
	}
	
    }
    if($ch == 4)
    {
	%pos_hash = ();
	%same_pos_hash = ();

	print "\n\nThe available POS are as follows :";
	print "\n\n";
	%pos_hash = all_pos();

	foreach $record(keys %pos_hash)
	{
	    print "\n$record";
	}


	print "\n\nEnter any one of the above POS : ";
	$POS = <STDIN>;
	chomp($POS);


	%same_pos_hash = same_pos($POS);

	foreach $record1(keys %same_pos_hash)
	{
	    print "\n$record1";
	}


    }
    if($ch == 6)
    {

	%sub_hash = ();
	%same_sub_hash = ();

	print "\n\nThe avaialable subject codes are as follows : ";
	%sub_hash = sub_codes();

	foreach $record(keys %sub_hash)
	{
	    print "\n$record";
	}

	print "\n\nEnter the subject code : ";
	$word = <STDIN>;
	chomp($word);
	%same_sub_hash = same_subcodes($word);

	
	foreach $record1(keys %same_sub_hash)
	{
	    print "\n$record1";
	}

    }
    if($ch == 5)
    {
	%sub_hash = ();
	%sub_hash = sub_codes();
	
	print "\n\nThe Subject Codes present in the Dictionary\n\n";
	
	foreach $record(keys %sub_hash)
	{
	    print "\n$record";
	}

    }
    if($ch == 3)
    {
	$ch2 = "y";
	$i = 0;
	@word = ();
	while($ch2 ne "n")
        {
	    print "\n\nThe words that you enter would be present in definitions of the outputted words "; 
	    print "\n\nEnter word : ";
	    $word[$i] = <STDIN>;
	    chomp($word[$i]);
	    $i++;
	    print "\n\nDo you want to enter another word?(y/n): ";
	    $ch2 = <STDIN>;
	    chomp($ch2);
	}
	%def_hash = similar_def(@word);
	foreach $word(keys %def_hash)
	{
	    print "WORD: $word\n";
	    foreach $rest(keys %{$def_hash{$word}})
	    {
		print "$rest\n";
	    }
	}
    }
    if($ch == 7)
    {
	#quit_ldoce();
	exit(0);
    }
    print "\n\nPress any key to continue......";
    <STDIN>;
}

